# shout/plugs/list.py
#
#

""" lists various stuff. """

## atl imports

from atl.utils import striphtml, ptime, dtime, tdiff
from atl import cmnds, plugins, tools, config, Object
from atl.generic import need_skip

## basic imports

import datetime
import logging
import time

## list command

def handle_list(event):
    try: p, attrs = event.rest.split(" ", 1) ; attrs = attrs.split()
    except ValueError: p = event.rest ; attrs = []
    if p == "config": event.reply("config is: %s" % " ".join(config.show_items())) ; return
    try: store = getattr(plugins.get(p), "store")
    except AttributeError:
        cmndlist = list(cmnds.keys()) + list(tools.keys())
        event.reply("commands are: %s" % " ".join(cmndlist))
        return
    c = 0
    opts = event.options
    objs = sorted(store.objects(), key=lambda o: o.estamp)
    next = True
    for obj in objs:
        if need_skip(obj, black=["html",], white=["text",]): continue
        c += 1
        obj.otype = "txt"
        fr = ptime(opts.fr or "1984-01-01")
        to = ptime(opts.to or "2013-12-30")
        try: diff = int(opts.diff)  
        except ValueError: diff = 0
        daysdiff = diff*60*60*24
        tmp = Object(**obj)
        tmp.nr = c
        if obj.estamp:
            if obj.estamp < fr.timestamp(): continue
            if obj.estamp > to.timestamp(): continue
            if daysdiff and (time.time() - obj.estamp) > daysdiff: continue 
        if obj.estamp: tmp.days = datetime.timedelta(-1, time.time() - obj.estamp)
        result = ""
        value = ""
        lines = 0
        if "txt" not in attrs: attrs.append("txt")
        if "text" not in attrs: attrs.append("text")
        for attr in attrs:
            try: value = tmp[attr]
            except KeyError:
                if attr in opts: next = False ; break
                continue
            if not value: continue
            if attr in opts and str(opts[attr]) not in str(value): next = False ; break
            result += '%s: %s ' % (attr, value) ; lines += 1
        if not next: next = True ; continue
        otype = opts.otype or obj.otype
        if otype not in ["txt", ]: event.reply(tmp.dump() + "\r\n") ; continue
        if opts.grep and opts.grep not in result: continue
        if result: event.reply(result)
    logging.warn("%s objects counted" % c)
    logging.warn("used options: %s" % opts)
 
cmnds.register("list", handle_list)
